// Code generated by cdpgen. DO NOT EDIT.

// Package indexeddb implements the IndexedDB domain.
package indexeddb

import (
	"context"

	"github.com/mafredri/cdp/protocol/internal"
	"github.com/mafredri/cdp/rpcc"
)

// domainClient is a client for the IndexedDB domain.
type domainClient struct{ conn *rpcc.Conn }

// NewClient returns a client for the IndexedDB domain with the connection set to conn.
func NewClient(conn *rpcc.Conn) *domainClient {
	return &domainClient{conn: conn}
}

// ClearObjectStore invokes the IndexedDB method. Clears all entries from an
// object store.
func (d *domainClient) ClearObjectStore(ctx context.Context, args *ClearObjectStoreArgs) (err error) {
	if args != nil {
		err = rpcc.Invoke(ctx, "IndexedDB.clearObjectStore", args, nil, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "IndexedDB.clearObjectStore", nil, nil, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "IndexedDB", Op: "ClearObjectStore", Err: err}
	}
	return
}

// DeleteDatabase invokes the IndexedDB method. Deletes a database.
func (d *domainClient) DeleteDatabase(ctx context.Context, args *DeleteDatabaseArgs) (err error) {
	if args != nil {
		err = rpcc.Invoke(ctx, "IndexedDB.deleteDatabase", args, nil, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "IndexedDB.deleteDatabase", nil, nil, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "IndexedDB", Op: "DeleteDatabase", Err: err}
	}
	return
}

// DeleteObjectStoreEntries invokes the IndexedDB method. Delete a range of
// entries from an object store
func (d *domainClient) DeleteObjectStoreEntries(ctx context.Context, args *DeleteObjectStoreEntriesArgs) (err error) {
	if args != nil {
		err = rpcc.Invoke(ctx, "IndexedDB.deleteObjectStoreEntries", args, nil, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "IndexedDB.deleteObjectStoreEntries", nil, nil, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "IndexedDB", Op: "DeleteObjectStoreEntries", Err: err}
	}
	return
}

// Disable invokes the IndexedDB method. Disables events from backend.
func (d *domainClient) Disable(ctx context.Context) (err error) {
	err = rpcc.Invoke(ctx, "IndexedDB.disable", nil, nil, d.conn)
	if err != nil {
		err = &internal.OpError{Domain: "IndexedDB", Op: "Disable", Err: err}
	}
	return
}

// Enable invokes the IndexedDB method. Enables events from backend.
func (d *domainClient) Enable(ctx context.Context) (err error) {
	err = rpcc.Invoke(ctx, "IndexedDB.enable", nil, nil, d.conn)
	if err != nil {
		err = &internal.OpError{Domain: "IndexedDB", Op: "Enable", Err: err}
	}
	return
}

// RequestData invokes the IndexedDB method. Requests data from object store
// or index.
func (d *domainClient) RequestData(ctx context.Context, args *RequestDataArgs) (reply *RequestDataReply, err error) {
	reply = new(RequestDataReply)
	if args != nil {
		err = rpcc.Invoke(ctx, "IndexedDB.requestData", args, reply, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "IndexedDB.requestData", nil, reply, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "IndexedDB", Op: "RequestData", Err: err}
	}
	return
}

// GetMetadata invokes the IndexedDB method. Gets metadata of an object store
func (d *domainClient) GetMetadata(ctx context.Context, args *GetMetadataArgs) (reply *GetMetadataReply, err error) {
	reply = new(GetMetadataReply)
	if args != nil {
		err = rpcc.Invoke(ctx, "IndexedDB.getMetadata", args, reply, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "IndexedDB.getMetadata", nil, reply, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "IndexedDB", Op: "GetMetadata", Err: err}
	}
	return
}

// RequestDatabase invokes the IndexedDB method. Requests database with given
// name in given frame.
func (d *domainClient) RequestDatabase(ctx context.Context, args *RequestDatabaseArgs) (reply *RequestDatabaseReply, err error) {
	reply = new(RequestDatabaseReply)
	if args != nil {
		err = rpcc.Invoke(ctx, "IndexedDB.requestDatabase", args, reply, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "IndexedDB.requestDatabase", nil, reply, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "IndexedDB", Op: "RequestDatabase", Err: err}
	}
	return
}

// RequestDatabaseNames invokes the IndexedDB method. Requests database names
// for given security origin.
func (d *domainClient) RequestDatabaseNames(ctx context.Context, args *RequestDatabaseNamesArgs) (reply *RequestDatabaseNamesReply, err error) {
	reply = new(RequestDatabaseNamesReply)
	if args != nil {
		err = rpcc.Invoke(ctx, "IndexedDB.requestDatabaseNames", args, reply, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "IndexedDB.requestDatabaseNames", nil, reply, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "IndexedDB", Op: "RequestDatabaseNames", Err: err}
	}
	return
}
